unit Backup_Restore;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ComCtrls, IBServices, FileCtrl;

type
  TfrmBackup = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label1: TLabel;
    edBackup: TEdit;
    SpeedButton2: TSpeedButton;
    IBBackup: TIBBackupService;
    IBRestore: TIBRestoreService;
    ProgressBar1: TProgressBar;
    Lista: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    SpeedButton1: TSpeedButton;
    procedure SpeedButton2Click(Sender: TObject);
    procedure IBBackupAttach(Sender: TObject);
    procedure IBRestoreAttach(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure TabSheet2Show(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure edBackupKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListaKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmBackup: TfrmBackup;

implementation

uses DataModule, Unit1, Formulas;

{$R *.dfm}

function CriaSubDir(const NomeSubDir: string): boolean;
var
  Caminho: string;
begin
  Caminho := ExtractFilePath(ParamStr(0)) + NomeSubDir;
  if DirectoryExists(Caminho) then
  Result := true
  else
  Result := CreateDir(Caminho);
end;

function Termo(APosicao: Integer; ASeparador,ALinha: String): String;
var
  sAux: TStringList;
begin
  Result:='';
  sAux:=TStringList.Create;
  sAux.Text:=StringReplace(ALinha,ASeparador,#13#10,[rfReplaceAll, rfIgnoreCase]);
  if APosicao <= sAux.Count then
    Result:=sAux.Strings[APosicao-1];
  sAux.Free;
end;


procedure TfrmBackup.SpeedButton2Click(Sender: TObject);
begin
if not DirectoryExists(Diretorio+'Backup') then
   CreateDir(Diretorio+'backup');
if edBackup.Text = '' then begin
   showmessage('Informe um Nome para o Arquivo de Backup');
   abort;
   end;
with IbBackup do begin
     try
     dados.Base.Close;
     Attach;
     ServerName:=TCP;
     Databasename:= conexao;
     BackupFile.Add(ExtractFilePath(application.ExeName)+'Backup\'+edbackup.text+'.fbk');
     Active := true;
     ServiceStart;
     showmessage('Backup Realizado com Sucesso');
     except
     on E : exception do
     showmessage('Erro no Backup: '+E.message);
     end;
end;
ibbackup.Free;
Dados.Base.DatabaseName := TCP + ':' + conexao;
dados.Base.Open;
progressbar1.Position := 0;
end;

procedure TfrmBackup.IBBackupAttach(Sender: TObject);
begin
progressbar1.Position := ibbackup.BufferSize
end;

procedure TfrmBackup.IBRestoreAttach(Sender: TObject);
begin
progressbar1.Position := ibrestore.BufferSize
end;

procedure TfrmBackup.SpeedButton1Click(Sender: TObject);
begin
if lista.FileName = '' then begin
   showmessage('Selecione um Backup para Restaurar');
   abort;
   end;
with IbRestore do begin
     try
     dados.Base.Close;
     Attach;
     ServerName:=TCP;
     Databasename.Add(conexao);
     BackupFile.Add(lista.FileName);
     Active := true;
     ServiceStart;
     showmessage('Restaurao Realizada com Sucesso');
     except
     on E : exception do
     showmessage('Erro na Restaurao: '+E.message);
     end;
end;
ibRestore.Free;
dados.Base.DatabaseName := TCP + ':' + conexao;
dados.Base.Open;
progressbar1.Position := 0;
end;

procedure TfrmBackup.TabSheet2Show(Sender: TObject);
begin
lista.Directory := ExtractFilePath(Application.ExeName)+'Backup';
lista.Update;
end;

procedure TfrmBackup.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = vk_Escape then close;
end;

procedure TfrmBackup.FormShow(Sender: TObject);
Var Dia, Mes, Ano : Word;
begin
DecodeDate(date, ano, mes, dia);
tabsheet1.Show;
edbackup.SetFocus;
edbackup.Text := inttostr(dia)+'-'+inttostr(mes)+'-'+inttostr(ano);
end;

procedure TfrmBackup.edBackupKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = 13 then speedbutton2.Click;
end;

procedure TfrmBackup.ListaKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
Var i : integer;
begin
if key = vk_delete then begin
   if lista.ItemIndex = -1 then begin
     showmessage('Nenhum Arquivo Selecionado');
     abort;
     end;
   i := lista.ItemIndex;
   Mensagem('Deseja Excluir este Arquivo de Backup Permanentemente',lista.Items[i]);
   deletefile(lista.FileName);
   lista.Update;
   end;
end;

end.
