unit Configurar_Campos;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, DB, IBCustomDataSet, ComCtrls, ExtCtrls;

type
  TfrmConfigurar = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Formulas: TTabSheet;
    Label1: TLabel;
    LTabela: TLabel;
    Label2: TLabel;
    Lista: TListBox;
    Label3: TLabel;
    edTipo: TEdit;
    Label4: TLabel;
    ComboMask: TComboBox;
    Label5: TLabel;
    edExemplo: TEdit;
    SpeedButton1: TSpeedButton;
    Panel1: TPanel;
    ComboFormulas: TComboBox;
    Label6: TLabel;
    SpeedButton2: TSpeedButton;
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListaClick(Sender: TObject);
    procedure edTipoChange(Sender: TObject);
    procedure ComboMaskChange(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    function TipoCampo(Campo: TFieldType): String;
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmConfigurar: TfrmConfigurar;

implementation

uses DataModule, Formulario, Inifiles, Unit1, Formulas;

{$R *.dfm}

procedure TfrmConfigurar.edTipoChange(Sender: TObject);
begin
if edtipo.Text = 'MEMORANDO' then
   ComboMask.Clear;
if edTipo.Text = 'DATA' then
   ComboMask.Clear;
if edTipo.Text = 'VALOR' then begin
   ComboMask.Clear;
   ComboMask.Items.Add('R$ ###,##0.00');
end;
if edTipo.Text = 'TEXTO' then begin
   ComboMask.Clear;
   ComboMask.Items.Add('(00) 0000-0000');
   ComboMask.Items.Add('(0000) 0000-0000');
   ComboMask.Items.Add('(00)0000-0000');
   ComboMask.Items.Add('(0000)0000-0000');
   ComboMask.Items.Add('00.000-000');
   ComboMask.Items.Add('000.000.000-00');
   ComboMask.Items.Add('00.000.000/0000-00');
end;
end;

procedure TfrmConfigurar.FormShow(Sender: TObject);
begin
dados.TABELA.GetFieldNames(lista.Items);
//dados.TABELA.FieldByName('id').DataType.ftWideString
end;

function TfrmConfigurar.TipoCampo(Campo: TFieldType): String;
begin
    case campo of
       ftFixedChar  : Result :='TEXTO';
       ftWideString : Result :='TEXTO';
       ftString     : Result :='TEXTO';
       ftMemo       : Result :='MEMORANDO';
       ftBlob       : Result :='MEMORANDO';
       ftUnknown    : Result :='TEXTO';
       ftInteger    : Result :='INTEIRO';
       ftFloat      : Result :='NUMERO';
       ftBCD        : Result :='VALOR';
       ftAutoInc    : Result :='INTEIRO';
       ftDate       : Result :='DATA';
       ftDateTime   : Result :='DATA';
    else
       Result :=Result;
    end;
end;


procedure TfrmConfigurar.ListaClick(Sender: TObject);
var i : integer;
begin
i := lista.ItemIndex;
edtipo.Text := (tipoCampo(dados.TABELA.FieldByName(Lista.Items[i]).DataType));
ComboMask.ItemIndex := -1;
edExemplo.Clear;
end;

procedure TfrmConfigurar.SpeedButton1Click(Sender: TObject);
Var i : integer;
begin
//TIBBCDFIELD(dados.TABELA.FieldByName('valor')).currency:=true;
try
i := lista.ItemIndex;
Config := Tinifile.Create(Diretorio+'Config.dat');
if TipoCampo(dados.TABELA.fieldbyname(lista.Items[i]).DataType) = 'DATA' then begin
   if combomask.ItemIndex = 0 then
   Config.WriteString(LTabela.Caption,lista.Items[i],'00/00/00') else
   Config.WriteString(LTabela.Caption,lista.Items[i],'00/00/0000');
end else begin
Config.WriteString(LTabela.Caption,lista.Items[i],ComboMask.Text);
end;
finally
Config.Free;
end;
Showmessage('Configurao Salva com Sucesso');
end;

procedure TfrmConfigurar.ComboMaskChange(Sender: TObject);
begin
if edTipo.Text = 'DATA' then
   case ComboMask.ItemIndex of
      0 : edExemplo.Text := '01/01/09';
      1 : edExemplo.Text := '01/01/2009';
   end;
if edTipo.Text = 'VALOR' then
   case ComboMask.ItemIndex of
      0 : edExemplo.Text := 'R$ 1.000,00';
   end;
if edTipo.Text = 'TEXTO' then
   case ComboMask.ItemIndex of
      0 : edExemplo.Text := '(44) 1234-5678';
      1 : edExemplo.Text := '(0044) 1234-5678';
      2 : edExemplo.Text := '(44)1234-5678';
      3 : edExemplo.Text := '(0044)1234-5678';
      4 : edExemplo.Text := '12.345-678';
      5 : edExemplo.Text := '123.456.789-11';
      6 : edExemplo.Text := '12.345.678/9123-45';
   end;
if edTipo.Text = 'INTEIRO' then edExemplo.Text := '1';
end;

procedure TfrmConfigurar.FormCreate(Sender: TObject);
begin
tabsheet1.Show;
end;

procedure TfrmConfigurar.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = vk_escape then close;
end;

procedure TfrmConfigurar.SpeedButton2Click(Sender: TObject);
Var i : integer;
begin
try
i := lista.ItemIndex;
Config := Tinifile.Create(Diretorio+'Config.dat');
Config.WriteString(LTabela.Caption,'F'+lista.Items[i],ComboFormulas.Text);
finally
Config.Free;
end;
Showmessage('Configurao Salva com Sucesso');
end;

end.
