unit DataModule;

interface

uses
  SysUtils, Classes, IBCustomDataSet, IBUpdateSQL, DB, IBDatabase, IBQuery, dialogs,
  IBTable, DBClient, Provider, Inifiles, IBStoredProc;

type
  TDADOS = class(TDataModule)
    Base: TIBDatabase;
    Query: TIBQuery;
    IBTransaction1: TIBTransaction;
    IBTable: TIBQuery;
    dspTable: TDataSetProvider;
    TABELA: TClientDataSet;
    IBU: TIBUpdateSQL;
    IBS: TIBQuery;
    procedure CreateDataBase(const ADataBase: String);
    procedure CreateTabela(Const Script : string);
    procedure TABELAAfterPost(DataSet: TDataSet);
    procedure TABELAAfterDelete(DataSet: TDataSet);
    procedure DataModuleCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DADOS: TDADOS;
  Config : Tinifile;

implementation

uses Formulario, Login, Unit1, Criar_Tabelas;

{$R *.dfm}

procedure TDados.CreateDataBase(const ADataBase: String);
var
  DataBase : TIBDatabase;
begin
  DataBase :=  TIBDatabase.Create( nil );
  try
    try
      with DataBase do
        begin
          DatabaseName := ADataBase;
          SQLDialect   := 3;
          Params.Clear;
          Params.Add('USER ''SYSDBA''');
          Params.Add('PASSWORD ''masterkey''');
          Params.Add('PAGE_SIZE 16384');
          Params.Add('DEFAULT CHARACTER SET ISO8859_1');
          CreateDatabase;
        end; // WITH CriaBanco DO
    finally
      FreeAndNil(DataBase);
//      Showmessage('DataBase Criada Com Sucesso '+ADataBase)
    end;
  except
      raise Exception.Create('ERROR : CreateDataBase');
  end;
end;

procedure TDados.CreateTabela(Const Script : string);
begin
try
with Query do begin
     close;
     sql.Clear;
     sql.Text := Script;
     Execsql;
     free;
     if seg = false then
     Showmessage('Tabela Criada com Sucesso');
end;
Except
  on E : exception do begin
  if seg = true then abort;
  raise Exception.Create('Erro na Criao da Tabela: '+E.Message);
end;end;
end;

procedure TDADOS.TABELAAfterPost(DataSet: TDataSet);
begin
tabela.ApplyUpdates(0);
   if dados.IBTransaction1.InTransaction then
      dados.IBTransaction1.Commit;
end;

procedure TDADOS.TABELAAfterDelete(DataSet: TDataSet);
begin
tabela.ApplyUpdates(0);
   if dados.IBTransaction1.InTransaction then
      dados.IBTransaction1.Commit;
end;

procedure TDADOS.DataModuleCreate(Sender: TObject);
begin
Try
dados.Base.DatabaseName := TCP + ':' + Conexao;
Dados.Base.Open;
except
end;
Try
IBS.Open;
if frmTabelas <> nil then abort;
if IBS.RecordCount > 0 then begin
   try
   frmLogin:=TfrmLogin.Create(self);
   frmLogin.ShowModal;
   finally
   frmLogin.Free;
   end;
end;
except
end;
end;

end.
