unit Formulas;

interface

Uses SysUtils, Windows, Dialogs, Forms, DataModule, DB, classes, DBweb,
     ComObj, XMLDoc, XMLIntf, Variants, IBQuery, DBTables, DBClient, ShellApi;


procedure CPFCNPJ(Numero : string);
function Calcular(TCampo : string; TDs : TDataSource):string;
procedure ExpTXT(DataSet: TDataSet; Arq: string);
procedure Exportar(DataSet: TDataSet; Tabela: string; Arq: string; Ext: string);
procedure Mensagem(Atitulo,Amensagem: String);

implementation

uses Unit1;

procedure Mensagem(Atitulo,Amensagem: String);
var
Button: Integer;
Titulo : Array[0..100] of Char;
Mensagem : Array[0..200] of Char;
begin
StrPCopy(Titulo, Atitulo);
StrPCopy(Mensagem, AMensagem);
Button := Application.MessageBox (Mensagem,Titulo, MB_YESNO+mb_DefButton2+MB_ICONQUESTION);
if button = idno then
   Abort;
end;

procedure Exportar(DataSet: TDataSet; Tabela: string; Arq: string; Ext: string);
var
  shtml     : widestring;
  htmlfile  : TextFile;
  i         : integer;
  AvailableFields: set of  TFieldType;
//  bookmark : TBytes;
  bookmark : tbookmarkstr;
begin
//bookmark := DataSet.Bookmark;
bookmark := dataset.Bookmark;
DataSet.DisableControls;
DataSet.First;
AvailableFields:=[ftInteger, ftWideString, ftDate,  ftBcd, ftmemo, ftstring];
// --> create a html page
//html header
  shtml:= '<html> <head> <title>';
  shtml:= shtml + Tabela;
  shtml:= shtml + '</title></head>' + #13#10;
  shtml:= shtml + '<body>' + #13#10;
  shtml:= shtml + 'TABELA: ' + Tabela + '' + #13#10;

//table header
  shtml:= shtml + '<table border="1" width="100%">' + #13#10;
  shtml:= shtml + '<tr>' + #13#10;
  for i:=0 to DataSet.FieldCount-1 do
  begin
    if DataSet.Fields[i].DataType in AvailableFields  then
    begin
      shtml:= shtml + '<td>';
      shtml:= shtml +
              '' +
              DataSet.Fields.Fields[i].DisplayName +
              '';
      shtml:= shtml + '</td>' + #13#10;
    end;
  end;{for}
  shtml:= shtml + '</tr>' + #13#10;

//table body
  while not DataSet.Eof do
  begin
    shtml:= shtml + '<tr>' + #13#10;
    for i:=0 to DataSet.FieldCount-1 do
    begin
      if DataSet.Fields.Fields[i].DataType in AvailableFields then
      begin
        shtml:= shtml + '<td>';
        if DataSet.Fields.Fields[i].DataType = ftBcd then begin
        shtml:= shtml + formatfloat('R$ ###,##0.00', DataSet.Fields.Fields[i].AsCurrency);
        end else begin
        if DataSet.Fields.Fields[i].AsString = '' then
        shtml:= shtml + '-' else
        shtml:= shtml + DataSet.Fields.Fields[i].AsString;
        shtml:= shtml + '</td>' + #13#10;
        end;
      end;
    end;{for}
    shtml:= shtml + '</tr>' + #13#10;
    DataSet.Next;
  end;{while}
  shtml:= shtml + '</table>' + #13#10;
  shtml:= shtml + '</body></html>';
// --> save in a htm file
 AssignFile(htmlfile,ChangeFileExt(Diretorio+'Relatorios\'+Tabela,'.'+Ext));
 Rewrite(htmlfile);
 WriteLn(htmlfile, shtml);
 CloseFile(htmlfile);
 DataSet.Bookmark := bookmark;
 DataSet.EnableControls;
ShellExecute(0, 'open', pchar(Diretorio+'Relatorios\'+trim(Tabela)+'.'+Ext), nil, nil, SW_SHOW);
end;

procedure ExpTXT(DataSet: TDataSet; Arq: string);
var
  i: integer;
  sl: TStringList;
  st: string;
begin
  DataSet.First;
  sl := TStringList.Create;
  try
    st := '';
    for i := 0 to DataSet.Fields.Count - 1 do
      st := st + DataSet.Fields[i].DisplayLabel + ' ';
    sl.Add(st);
    DataSet.First;
    while not DataSet.Eof do
    begin
      st := '';
      for i := 0 to DataSet.Fields.Count - 1 do
        st := st + DataSet.Fields[i].AsString + ' ';
      sl.Add(st);
      DataSet.Next;
    end;
    sl.SaveToFile(Arq);
  finally
     sl.free;
  end;
end;

function cpf(num: string): boolean;
var
n1,n2,n3,n4,n5,n6,n7,n8,n9: integer;
d1,d2: integer;
digitado, calculado: string;
begin
n1:=StrToInt(num[1]);
n2:=StrToInt(num[2]);
n3:=StrToInt(num[3]);
n4:=StrToInt(num[4]);
n5:=StrToInt(num[5]);
n6:=StrToInt(num[6]);
n7:=StrToInt(num[7]);
n8:=StrToInt(num[8]);
n9:=StrToInt(num[9]);
d1:=n9*2+n8*3+n7*4+n6*5+n5*6+n4*7+n3*8+n2*9+n1*10;
d1:=11-(d1 mod 11);
if d1>=10 then d1:=0;
d2:=d1*2+n9*3+n8*4+n7*5+n6*6+n5*7+n4*8+n3*9+n2*10+n1*11;
d2:=11-(d2 mod 11);
if d2>=10 then d2:=0;
calculado:=inttostr(d1)+inttostr(d2);
digitado:=num[10]+num[11];
if calculado=digitado then cpf:=true;
if calculado<>digitado then begin
   cpf:=false;
   messagebeep(52);
   showmessage('CPF Incorreto, Corriga o CPF ou deixe em branco');
end;end;

function cgc(num: string): boolean;
var
n1,n2,n3,n4,n5,n6,n7,n8,n9,n10,n11,n12: integer;
d1,d2: integer;
digitado, calculado: string;
begin
n1:=StrToInt(num[1]);
n2:=StrToInt(num[2]);
n3:=StrToInt(num[3]);
n4:=StrToInt(num[4]);
n5:=StrToInt(num[5]);
n6:=StrToInt(num[6]);
n7:=StrToInt(num[7]);
n8:=StrToInt(num[8]);
n9:=StrToInt(num[9]);
n10:=StrToInt(num[10]);
n11:=StrToInt(num[11]);
n12:=StrToInt(num[12]);
d1:=n12*2+n11*3+n10*4+n9*5+n8*6+n7*7+n6*8+n5*9+n4*2+n3*3+n2*4+n1*5;
d1:=11-(d1 mod 11);
if d1>=10 then d1:=0;
d2:=d1*2+n12*3+n11*4+n10*5+n9*6+n8*7+n7*8+n6*9+n5*2+n4*3+n3*4+n2*5+n1*6;
d2:=11-(d2 mod 11);
if d2>=10 then d2:=0;
calculado:=inttostr(d1)+inttostr(d2);
digitado:=num[13]+num[14];
if calculado=digitado then cgc:=true;
if calculado<>digitado then begin
  cgc:=false;
  messagebeep(52);
  showmessage('CNPJ Invlido, Corriga o CNPJ ou deixe em branco!');
end;end;

procedure CPFCNPJ(numero : string);
begin
if length(numero) <= 11 then cpf(numero) else cgc(numero);
end;

function Calcular(TCampo : string; TDs : TDataSource) : string;
var
//bookmark : TBytes;
bookmark : tbookmarkstr;
tot      : real;
begin
     bookmark := Tds.DataSet.Bookmark;
//     bookmark := Tds.dataset.Bookmark;
     try
      Tds.DataSet.DisableControls;
      tot := 0;
    try
    Tds.DataSet.First;
    while not Tds.DataSet.Eof do begin
    tot := tot + Tds.DataSet.fieldbyname(TCampo).AsCurrency;
    Tds.DataSet.next;
    end;
    finally
    Tds.DataSet.EnableControls;
    end;
    finally
    Tds.DataSet.Bookmark := bookmark;
    Result := 'R$ ' + format('%n',[tot]);
    end;
end;

end.
