unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IBDatabase, DB, IBCustomDataSet, IBQuery, StdCtrls, Grids, DBGrids,
  DBCtrls, ExtCtrls, SqlExpr, IBUpdateSQL, ComCtrls, Menus, XPMan, tlhelp32, shellapi,
  Midas, sSkinManager, ImgList, ToolWin;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    Timer1: TTimer;
    MainMenu1: TMainMenu;
    Arquivo1: TMenuItem;
    Sair1: TMenuItem;
    Manuteno1: TMenuItem;
    CriarTabelas1: TMenuItem;
    BackupeRestore1: TMenuItem;
    Sobre1: TMenuItem;
    SobreoSistema1: TMenuItem;
    XPManifest1: TXPManifest;
    Formulario1: TMenuItem;
    Configuraes1: TMenuItem;
    Calculadora1: TMenuItem;
    ArquivodeAjuda1: TMenuItem;
    Skin: TsSkinManager;
    ToolBar1: TToolBar;
    ImageList1: TImageList;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Sair1Click(Sender: TObject);
    procedure CriarTabelas1Click(Sender: TObject);
    procedure Formulario1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BackupeRestore1Click(Sender: TObject);
    procedure SobreoSistema1Click(Sender: TObject);
    procedure Configuraes1Click(Sender: TObject);
    procedure Calculadora1Click(Sender: TObject);
    procedure ArquivodeAjuda1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Diretorio, Conexao, TCP : string;
  Rede : boolean;

implementation

uses DataModule, Criar_Tabelas, Formulario, Backup_Restore, Inifiles,
     Configurar_Conexao, About;

{$R *.dfm}

procedure TForm1.CriarTabelas1Click(Sender: TObject);
begin
try
frmTabelas:=TfrmTabelas.Create(self);
frmTabelas.ShowModal;
finally
frmTabelas.Release
end;
end;

function FindProcess(ProcessName: string): DWord;
var ContinueLoop: BOOL;
    FSnapshotHandle: THandle;
    FProcessEntry32: TProcessEntry32;
begin
Result := 0;
FSnapshotHandle := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
FProcessEntry32.dwSize := SizeOf(FProcessEntry32);
ContinueLoop := Process32First(FSnapshotHandle, FProcessEntry32);
while ContinueLoop and (not Boolean(Result)) do  begin
if ((UpperCase(ExtractFileName(FProcessEntry32.szExeFile)) =  UpperCase(ProcessName))
   or (UpperCase(FProcessEntry32.szExeFile) =  UpperCase(ProcessName)))
   then  Result := FProcessEntry32.th32ProcessID;
   ContinueLoop := Process32Next(FSnapshotHandle, FProcessEntry32);
   end;
end;

function Executa(const FileName, Params: string;
const WindowState: Word): boolean;
var
SUInfo: TStartupInfo;
ProcInfo: TProcessInformation;
CmdLine: string;
begin
{ Coloca o nome do arquivo entre aspas. Isto  necessrio devido aos espaos contidos em nomes longos }
CmdLine := '"' + Filename + '"' + Params;
FillChar(SUInfo, SizeOf(SUInfo), #0);
with SUInfo do begin
cb := SizeOf(SUInfo);
dwFlags := STARTF_USESHOWWINDOW;
wShowWindow := WindowState;
end;
Result := CreateProcess(nil, PChar(CmdLine), nil, nil, false,
CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS, nil,
PChar(ExtractFilePath(Filename)), SUInfo, ProcInfo);
{ Aguarda at ser finalizado }
if Result then begin
WaitForSingleObject(ProcInfo.hProcess, INFINITE);
{ Libera os Handles }
CloseHandle(ProcInfo.hProcess);
CloseHandle(ProcInfo.hThread);
end;
end;

procedure TForm1.FormCreate(Sender: TObject);
Var i : integer;
begin
Diretorio:= ExtractFilePath(Application.ExeName);
{Testar se o Firebird Est Instalado se no tiver instala--------------------------------------------}
i := FindProcess('fbguard.exe');
try
if i = 0 then begin
   showmessage('Ateno, no foi Encontrado a Instalao do Gerenciado de Banco de Dados'+#13+
               'Por Favor Instale o Gerenciador Agora!');
   Executa(Diretorio+'Firebird-2.5','',sw_shownormal);
end;
except
showmessage('O Sisbase necessita do gerenciador do banco de dados instalado'+#13+
            'por favor instale-o manualmente na pasta do programa'+#13+
            '( Firebird-2.5.exe )');
end;
{----------------------------------------------------------------------------------------------------}
DecimalSeparator := ',';
ShortDateFormat  := 'dd/mm/yyyy';
statusbar1.Panels[0].Text := timetostr(now);
statusbar1.Panels[1].Text := FormatDateTime('""dddd", "dd" de "mmmm" de "yyyy"', date());
if FileExists(Diretorio+'Config.dat') then begin
   try
   Config := Tinifile.Create(Diretorio+'Config.dat');
   if Config.ReadString('BASE','REDE','') = 'SIM' then Rede := True;
   TCP := Config.ReadString('BASE','IP','');
   Conexao := Config.ReadString('BASE','TABELA','');
   finally
   Config.Free;
   end;
end;
if not DirectoryExists(Diretorio+'Backup') then
   CreateDir(Diretorio+'Backup');
if not DirectoryExists(Diretorio+'Relatorios') then
   CreateDir(Diretorio+'Relatorios');
end;

procedure TForm1.Sair1Click(Sender: TObject);
begin
close;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
statusbar1.Panels[0].Text := timetostr(now);
end;

procedure TForm1.Formulario1Click(Sender: TObject);
begin
if dados.Base.Connected = false then begin
  showmessage('Crie Primeiro uma Tabela');
  try
  frmTabelas:=TfrmTabelas.Create(self);
  frmTabelas.ShowModal;
  finally
  frmTabelas.Release
  end;
  abort;
end;
Try
frmForm:=TfrmForm.Create(self);
dados.Query.Close;
frmForm.ShowModal;
finally
frmForm.Release;
end;end;

procedure TForm1.FormShow(Sender: TObject);
var
Button: Integer;
Titulo : Array[0..79] of Char;
Mensagem : Array[0..200] of Char;
begin
Skin.Active := false;
Skin.SkinDirectory := Diretorio;
Skin.SkinName := 'Opus';
Skin.Active := true;
if not FileExists(Diretorio+'\Config.dat') then begin
StrPCopy(Titulo, 'Primeiro Acesso ao Sistema');
StrPCopy(Mensagem, 'Configurar Sistema: '+#13+
                   '(SIM) para Configurar Conexo com Banco j Existente'+#13+
                   '(NO) para Criar um Banco de Dados' );
Button := Application.MessageBox (Mensagem,Titulo, MB_YESNO+mb_DefButton2+MB_ICONQUESTION);
if button = idno then
  try
  frmTabelas:=TfrmTabelas.Create(self);
  frmTabelas.ShowModal;
  finally
  frmTabelas.Release
  end;
if button = idyes then
  try
  frmConexao:=TfrmConexao.Create(self);
  frmConexao.ShowModal;
  finally
  frmConexao.Release
  end;
end else begin
   try
   Dados.Base.Close;
   Dados.Base.DatabaseName := TCP + ':' + Conexao;
   Dados.Base.Open;
   except
   on E : Exception do
   showmessage('Erro na Conexo'+E.message);
   end;
end;end;

procedure TForm1.BackupeRestore1Click(Sender: TObject);
begin
if dados.Base.Connected = false then begin
  showmessage('Crie Primeiro uma Tabela, ou Configure a Conexo');
  try
  frmTabelas:=TfrmTabelas.Create(self);
  frmTabelas.ShowModal;
  finally
  frmTabelas.Release
  end;
  abort;
end;
try
frmBackup:=TfrmBackup.Create(self);
frmBackup.ShowModal;
finally
frmBackup.Release;
end;end;

procedure TForm1.SobreoSistema1Click(Sender: TObject);
begin
try frmAbout := TfrmAbout.Create(self);
    frmAbout.ShowModal;
    finally
    frmAbout.Release;
end;end;

procedure TForm1.Configuraes1Click(Sender: TObject);
begin
try
frmConexao:=TfrmConexao.Create(self);
frmConexao.ShowModal;
finally
frmConexao.Release;
end;end;

procedure TForm1.Calculadora1Click(Sender: TObject);
begin
winexec('calc.exe',0);
end;

procedure TForm1.ArquivodeAjuda1Click(Sender: TObject);
begin
ShellExecute(0, 'open', pchar(diretorio+'Ajuda SYSBASE.mht'), nil, nil, SW_SHOW);
end;

end.
